from machine import UART
from time import sleep_ms
from network import Sigfox
import socket
import pycom

import binascii
from machine import Pin

##RGB Colors
red=0xff0000
yellow=0xffff00
green=0x00ff00
blue=0x0000ff
cyan=0x00feff
purple=0xc442a1
orange=0xff8b55
dark=0x000000
##  Define Sipy Pins and Hardware
push_button=Pin('P22',mode=Pin.IN, pull=Pin.PULL_DOWN)
com = UART(1, baudrate=9600, bits=8, parity=None, stop=1,pins=("G24","G11"))
sigfox = Sigfox(mode=Sigfox.SIGFOX, rcz=Sigfox.RCZ2)
# create a Sigfox socket
s = socket.socket(socket.AF_SIGFOX, socket.SOCK_RAW)
# print Sigfox Device ID
print(binascii.hexlify(sigfox.id()))
# print Sigfox PAC number
print(binascii.hexlify(sigfox.pac()))
# make the socket blocking
s.setblocking(True)
# configure it as uplink only
s.setsockopt(socket.SOL_SIGFOX, socket.SO_RX, False)


pycom.heartbeat(False)

#this function will remove the .
def remove_point(remove):
    nopointstr=""
    for point in remove:
        if (point!="."):
            nopointstr=nopointstr+point

    return nopointstr

#this function will check forn an empty string
def xstr(s):
    if s is None:
        return ''
    return str(s)

pycom.rgbled(red)
while True:
    sleep_ms(1000)
    sleep_ms(1000)

    mygps=com.readall()
    #check if there is something on mygps string
    if(xstr(mygps)):
        mygpsstr=str(mygps)
        print(mygps)
        mygps_msglist=mygpsstr.split("\\r\\n",6)
        #mygps_msglist=["b'$GPRMC,145453.00,A,2955.24270,N,09542.57669,W,0.584,,250217,,,A*63", '$GPVTG,,T,,M,0.584,N,1.082,K,A*21', '$GPGGA,145453.00,2955.24270,N,09542.57669,W,1,03,3.61,49.9,M,-24.6,M,,*5B', '$GPGSA,A,2,32,21,31,,,,,,,,,,3.74,3.61,1.00*06', "$GPGSV,4,1,15,08,09,284,,10,6'"]

        for i in range(len(mygps_msglist)):
         let=mygps_msglist[i].find("GPRMC")
         if (let!=-1):
             print("String Found")
             gprmc_list=mygps_msglist[i].split(",",8)
             print(gprmc_list)
             gps_time=gprmc_list[1]
             gps_status=gprmc_list[2]
             gps_latitud=gprmc_list[3]
             gps_latitud_dir=gprmc_list[4]
             gps_longitud=gprmc_list[5]
             gps_longitud_dir=gprmc_list[6]
             print(gps_time)
             print(gps_status)
             print(gps_latitud)
             print(gps_latitud_dir)
             print(gps_longitud)
             print(gps_longitud_dir)

             #check if the GPS fixed a position by checking on STATUS for A
             if (gps_status=="A"):
                 #make led blink
                 pycom.rgbled(green)
                 sleep_ms(300)
                 pycom.rgbled(dark)
                 sleep_ms(300)
                 pycom.rgbled(green)
                 ##################

                 gps_latitudnop= remove_point(gps_latitud)#remove point
                 gps_longitudnop= remove_point(gps_longitud)#remove point
                 latitud_int=int(gps_latitudnop)#convet to Int
                 longitud_int=int(gps_longitudnop)#convet to Int
                 lat_byte=[int(latitud_int>>i & 0xff) for i in (24,16,8,0)]#shift bytes
                 lon_byte=[int(longitud_int>>i & 0xff) for i in (24,16,8,0)]#shift bytes
                 gps_status_byte=ord(gps_status)
                 gps_latitud_dir_byte=ord(gps_latitud_dir)
                 gps_longitud_dir_byte=ord(gps_longitud_dir)

                 sigfox_payload=[lat_byte[0],lat_byte[1],lat_byte[2], lat_byte[3], lon_byte[0], lon_byte[1], lon_byte[2], lon_byte[3],gps_status_byte,gps_latitud_dir_byte, gps_longitud_dir_byte, gps_latitud_dir_byte]
                 print("Sigfox Payload")
                 print(sigfox_payload)
                 s.send(bytes(sigfox_payload))
                 #Make LED Blink
                 pycom.rgbled(blue)
                 sleep_ms(300)
                 pycom.rgbled(dark)
                 sleep_ms(300)
                 pycom.rgbled(blue)
                 sleep_ms(300)
                 pycom.rgbled(dark)
                 sleep_ms(300)
                 pycom.rgbled(blue)
                 sleep_ms(300)
                 pycom.rgbled(dark)
